<!doctype html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport"
        content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <title>Khadi's PWA</title>
  <link href="https://fonts.googleapis.com/css?family=Raleway:400,700" rel="stylesheet">
  <link rel="stylesheet" href="/src/css/app.css">
  <link rel="manifest" href="/manifest.json">
</head>
<body>
<header class="main-header">
  <h1 id="top">Khadi's PWA</h1>
  
</header>


<a href="/index.html" > Home </a><br>
<a href="#bottom"> Bottom</a><br>
<a href="/DeviceTouch.html"> Touch Gestures & Device Positions </a><br>


<!---Video  and Audio Capture-->


<h2 id="video">Video & Audio Capture + Recording</h2>
<button id="btn-start-recording">Start </button>
<button id="btn-stop-recording" disabled>Stop </button><br>


<video controls autoplay playsinline style="object-fit:cover; width:320px; height:240px"></video>

<script src="/RecordRTC.js"></script>
<script>
var video = document.querySelector('video');

function captureCamera(callback) {
    navigator.mediaDevices.getUserMedia({ audio: true, video: true }).then(function(camera) {
        callback(camera);
    }).catch(function(error) {
        alert('Unable to capture your camera. Please check console logs.');
        console.error(error);
    });
}

function stopRecordingCallback() {
    video.src = video.srcObject = null;
    video.muted = false;
    video.volume = 1;
    video.src = URL.createObjectURL(recorder.getBlob());
    
    recorder.camera.stop();
    recorder.destroy();
    recorder = null;
}

var recorder; // globally accessible

document.getElementById('btn-start-recording').onclick = function() {
    this.disabled = true;
    captureCamera(function(camera) {
        video.muted = true;
        video.volume = 0;
        video.srcObject = camera;

        recorder = RecordRTC(camera, {
            type: 'video'
        });

        recorder.startRecording();

        // release camera on stopRecording
        recorder.camera = camera;

        document.getElementById('btn-stop-recording').disabled = false;
    });
};

document.getElementById('btn-stop-recording').onclick = function() {
    this.disabled = true;
    recorder.stopRecording(stopRecordingCallback);
};
</script>
<!---Video  and Audio Capture End-->
<hr>
<!---Location and Position-->
<h2 id="location">Geolocation</h2>
<button onclick="getLocation()">Try Me!</button>
    <p id="location"></p>


<script>
  function getLocation()
  {
     
      if (navigator.geolocation) { // Supported
          navigator.geolocation.getCurrentPosition(getPosition);
      } else { 
          alert("This browser does not support Geolocation.");
      }
  }
  function getPosition(position)
  {
      document.getElementById("location").innerHTML = 
          "Latitude: " + position.coords.latitude + "<br>" +
          "Longitude: " + position.coords.longitude;
  }
  </script>
<!---Location and Position END-->
<hr>

<!---Local Notif -->
<h2 id="localnot">Local Notification & Permissions</h2>
<p>
  <b><a href="/geolocation.html">Geolocation</a></b> permission status is <b id="geolocation-status">unknown</b>.
  
  <button onclick="requestGeolocation()">Request</button>
</p>
<p>
  <b><a href="/local-notifications.html">Notifications</a></b> permission status is <b id="notifications-status">unknown</b>.
  
  <button onclick="requestNotifications()">Request</button>
</p>

<p>
  <b><a href="/camera-microphone.html">Camera</a></b> permission status is <b id="camera-status">unknown</b>.
  
  <button onclick="requestCamera()">Request</button>
</p>
<p>
  <b><a href="/camera-microphone.html">Microphone</a></b> permission status is <b id="microphone-status">unknown</b>.
  
  <button onclick="requestMicrophone()">Request</button>
</p>
<p>
  <b><a href="/background-sync.html">Background Sync</a></b> permission status is <b id="background-sync-status">unknown</b>.
</p>

<p>
  <b><a href="/device-motion.html">Accelerometer</a></b> permission status is <b id="accelerometer-status">unknown</b>.
</p>

</div>

<p id="logTarget"></p>
<script> 
if ('permissions' in navigator) {
var logTarget = document.getElementById('logTarget');

function handleChange(permissionName, newState) {
  var timeBadge = new Date().toTimeString().split(' ')[0];
  var newStateInfo = document.createElement('p');
  newStateInfo.innerHTML = '' + timeBadge + ' State of ' + permissionName + ' permission status changed to ' + newState + '.';
  logTarget.appendChild(newStateInfo);
}

function checkPermission(permissionName, descriptor) {
  try {
  navigator.permissions.query(Object.assign({name: permissionName}, descriptor))
    .then(function (permission) {
      document.getElementById(permissionName + '-status').innerHTML = permission.state;
      permission.addEventListener('change', function (e) {
        document.getElementById(permissionName + '-status').innerHTML = permission.state;
        handleChange(permissionName, permission.state);
      });
    });
  } catch (e) {
  }
}

checkPermission('geolocation');
checkPermission('notifications');
checkPermission('camera');
checkPermission('microphone');
checkPermission('background-sync');
checkPermission('accelerometer');


var noop = function () {};
navigator.getUserMedia = (navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia);

function requestGeolocation() {
  navigator.geolocation.getCurrentPosition(noop);
}

function requestNotifications() {
  Notification.requestPermission();
}



function requestCamera() {
  navigator.getUserMedia({video: true}, noop, noop)
}

function requestMicrophone() {
  navigator.getUserMedia({audio: true}, noop, noop)
}
}
</script>

<!---Local Notif END-->

<hr>

<!---Clipboard -->
<h2 id="clipboard">Clipboard</h2>
<section>
  <label><input type="radio" name="api" value="async" checked> Use newer, asynchronous API</label>
</section>
<section>
 
 <p>
   <textarea class="js-cuttextarea">Write down some Notes!</textarea>
 </p>

 <p>
   <button class="js-textareacutbtn">Cut text</button>
   <button class="js-textareapastebtn">Paste text</button>
 </p>
</section>



<p id="logTargett"></p>




<script>
var logTarget = document.getElementById('logTargett');

function useAsyncApi() {
 return document.querySelector('input[value=async]').checked;
}

function log(event) {
 var timeBadge = new Date().toTimeString().split(' ')[0];
 var newInfo = document.createElement('p');
 newInfo.innerHTML = '' + timeBadge + ' ' + event + '.';
 logTarget.appendChild(newInfo);
}


function performCutTextarea() {
 var cutTextarea = document.querySelector('.js-cuttextarea');

 if (useAsyncApi()) {
   navigator.clipboard.writeText(cutTextarea.textContent)
     .then(() => {
       log('Async writeText successful, "' + cutTextarea.textContent + '" written');
       cutTextarea.textContent = '';
     })
     .catch(err => log('Async writeText failed with error: "' + err + '"'));
 } else {
   var hasSelection = document.queryCommandEnabled('cut');
   cutTextarea.select();
 
   try {
     var successful = document.execCommand('cut');
     var msg = successful ? 'successful' : 'unsuccessful';
     log('Cutting text command was ' + msg);
   } catch (err) {
     log('execCommand Error', err);
   }
 }
}

function performPaste() {
 var pasteTextarea = document.querySelector('.js-cuttextarea');
 
 if (useAsyncApi()) {
   navigator.clipboard.readText()
     .then((text) => {
       pasteTextarea.textContent = text;
       log('Async readText successful, "' + text + '" written');
     })
     .catch((err) => log('Async readText failed with error: "' + err + '"'));
 } else {
   pasteTextarea.focus();
   try {
     var successful = document.execCommand('paste');
     var msg = successful ? 'successful' : 'unsuccessful';
     log('Pasting text command was ' + msg);
   } catch (err) {
     log('execCommand Error', err);
   }
 }
}

// Get the buttons
var cutTextareaBtn = document.querySelector('.js-textareacutbtn');
var pasteTextareaBtn = document.querySelector('.js-textareapastebtn');

// Add click event listeners
cutTextareaBtn.addEventListener('click', performCutTextarea);
pasteTextareaBtn.addEventListener('click', performPaste);

function logUserOperation(event) {
 log('User performed ' + event.type + ' operation. Payload is: ' + event.clipboardData.getData('text/plain') + '');
}


document.addEventListener('copy', logUserOperation);
document.addEventListener('paste', logUserOperation);


</script>

<!---Clipboard END-->

<hr>
<!---Online State -->
<h2 id="state">Online State</h2>

<p>Initial connection state was <b id="status">unknown</b>.</p>

<div id="target"></div>
<script>
  document.getElementById('status').innerHTML = navigator.onLine ? 'online' : 'offline';

var target = document.getElementById('target');

function handleStateChange() {
  var timeBadge = new Date().toTimeString().split(' ')[0];
  var newState = document.createElement('p');
  var state = navigator.onLine ? 'online' : 'offline';
  newState.innerHTML = '' + timeBadge + ' Connection state changed to ' + state + '.';
  target.appendChild(newState);
}

window.addEventListener('online', handleStateChange);
window.addEventListener('offline', handleStateChange);


</script>

<!---Online State END-->

<hr>
<!---Battery Status -->
<h2 id="battery">Battery Status</h2>
<p>Initial battery status was <b id="charging">unknown</b>, charging time <b id="chargingTime">unknown</b>, discharging time <b id="dischargingTime">unknown</b>, level <b id="level">unknown</b>.</p>

<div id="targettt"></div>


<script>
if ('getBattery' in navigator || ('battery' in navigator && 'Promise' in window)) {
  var target = document.getElementById('targettt');

  function handleChange(change) {
    var timeBadge = new Date().toTimeString().split(' ')[0];
    var newState = document.createElement('p');
    newState.innerHTML = '' + timeBadge + ' ' + change + '.';
    target.appendChild(newState);
  }
  
  function onChargingChange() {
    handleChange('Battery charging changed to ' + (this.charging ? 'charging' : 'discharging') + '')
  }
  function onChargingTimeChange() {
    handleChange('Battery charging time changed to ' + this.chargingTime + ' s');
  }
  function onDischargingTimeChange() {
    handleChange('Battery discharging time changed to ' + this.dischargingTime + ' s');
  }
  function onLevelChange() {
    handleChange('Battery level changed to ' + this.level + '');
  }

  var batteryPromise;
  
  if ('getBattery' in navigator) {
    batteryPromise = navigator.getBattery();
  } else {
    batteryPromise = Promise.resolve(navigator.battery);
  }
  
  batteryPromise.then(function (battery) {
    document.getElementById('charging').innerHTML = battery.charging ? 'charging' : 'discharging';
    document.getElementById('chargingTime').innerHTML = battery.chargingTime + ' s';
    document.getElementById('dischargingTime').innerHTML = battery.dischargingTime + ' s';
    document.getElementById('level').innerHTML = battery.level;
    
    battery.addEventListener('chargingchange', onChargingChange);
    battery.addEventListener('chargingtimechange', onChargingTimeChange);
    battery.addEventListener('dischargingtimechange', onDischargingTimeChange);
    battery.addEventListener('levelchange', onLevelChange);
  });
}
</script>

<!---Batery Status END-->
<hr>
<!---Vibration -->
<h2 id="vibr">Vibration</h2>
<button onclick="vibrateSimple()">Vibrate for 500 ms</button>
<button onclick="vibratePattern()">Vibrate with pattern</button>
<script>
  function vibrateSimple() {
  navigator.vibrate(500);
}

function vibratePattern() {
  navigator.vibrate([100, 200, 300, 400, 500]);
}
</script>

<!---Vibration END-->
<hr>
<!---Zahlungen-->
<h2 id="bottom">Payment</h2>
<p><button onclick="donate()"> Buy me a Coffee! </button> (demo only)</p>

<p id="log"></p>

<p><small>Demo based on <a href="https://googlechrome.github.io/samples/paymentrequest/credit-cards/">Google Chrome GitHub repository</a>.</small></p>
<script>
/**
 * Builds PaymentRequest for credit cards, but does not show any UI yet.
 */
function initPaymentRequest() {
  let networks = ['amex', 'jcb', 'visa', 'maestro', 'mastercard'];
  
  let supportedInstruments = [{
    supportedMethods: 'basic-card',
    data: {
      supportedNetworks: networks, 
      supportedTypes: ['debit', 'credit', 'prepaid']
    }
  }, {
    supportedMethods: 'https://apple.com/apple-pay',
    data: {
        version: 2,
        supportedNetworks: networks,
        countryCode: 'US',
        merchantIdentifier: 'whatwebcando.today.sample',
        merchantCapabilities: ['supportsDebit', 'supportsCredit', 'supports3DS']
    }
  }];

  let details = {
    total: {label: 'Coffee', amount: {currency: 'EUR', value: '2.00'}},
    displayItems: [
      {
        label: 'Original amount',
        amount: {currency: 'EUR', value: '4.00'}
      },
      {
        label: 'Friends and family discount',
        amount: {currency: 'EUR', value: '-2.00'}
      }
    ]
  };

  return new PaymentRequest(supportedInstruments, details);
}

/**
 * Invokes PaymentRequest for credit cards.
 */
function onBuyClicked(request) {
  request.show()
    .then(instrumentResponse => sendPaymentToServer(instrumentResponse))
    .catch(err => document.getElementById('log').innerText = err);
}

/**
 * Simulates processing the payment data on the server.
 */
function sendPaymentToServer(instrumentResponse) {
  // There's no server-side component of these samples. No transactions are
  // processed and no money exchanged hands. Instantaneous transactions are not
  // realistic. Add a 2 second delay to make it seem more real.
  
  window.setTimeout(function () {
    instrumentResponse.complete('success')
        .then(() => document.getElementById('log').innerHTML = resultToTable(instrumentResponse))
        .catch(err => document.getElementById('log').innerText = err);
  }, 2000);
}

/**
 * Converts the payment instrument into a JSON string.
 */
function resultToTable(result) {
  return '' +
    '' +
    '' +
    '' +
    '' +
    '' +
    '' +
    'Method name' + result.methodName + 'Billing address' + (result.details.billingAddress || {}).addressLine + ', ' + (result.details.billingAddress || {}).city + 'Card number' + result.details.cardNumber + 'Security code' + result.details.cardSecurityCode + 'Cardholder name' + result.details.cardholderName + 'Expiry date' + result.details.expiryMonth + '/' + result.details.expiryYear + '';
}

function donate() {
  if (!window.PaymentRequest) {
    alert('This browser does not support Web Payments API');
    return;
  }
    
  let request = initPaymentRequest();
  onBuyClicked(request);
}
</script>

<!---Zahlungen END-->
<a href="#top"> Top</a><br>

    </div>
  </div>
    
  </div>
  


<!-- recommended -->
<script src="https://www.WebRTC-Experiment.com/RecordRTC.js"></script>
<!-- The core Firebase JS SDK is always required and must be listed first -->
<script src="/__/firebase/8.2.3/firebase-app.js"></script>

<!-- TODO: Add SDKs for Firebase products that you want to use
     https://firebase.google.com/docs/web/setup#available-libraries -->
<script src="/__/firebase/8.2.3/firebase-analytics.js"></script>

<!-- Initialize Firebase -->
<script src="/__/firebase/init.js"></script>
</body>
</html>